@echo off
title Remover
mode con: cols=80 lines=40
color 1F
setlocal enableExtensions enableDelayedExpansion
cls
set data_path=
set models_path[0]=
set /a total_paths=0
set /a total_dirs=0
set /a current_dir=0
set current_label=
set retry_label=
:start
set "current_label=start"
call :showTitle
:mainMenu
echo This script will help you remove unwanted clips from iStripper folders.
echo Press corresponding key on your keyboard and accept by pressing [Enter].
echo.
echo ------------------------------------------------
echo           MAIN MENU
echo ------------------------------------------------
echo  [1] Remove previews of non purchased cards
echo  [2] Remove regular demo files
echo  [3] Remove regular and interactive demo files
echo  [4] Remove inactive clips
echo  [5] Remove inactive cards
echo  [6] Remove deleted cards
echo  [7] Remove intermediate files
echo.
echo  [H] Help
echo  [A] About
echo  [Q] Quit
echo ------------------------------------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :start
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	goto :demo_not_purchased
)
if /i %_choice% == 2 (
	set flag=1
	goto :regular_demo
)
if /i %_choice% == 3 (
	set flag=1
	goto :regular_interactive_demo
)
if /i %_choice% == 4 (
	set flag=1
	goto :inactive_clips
)
if /i %_choice% == 5 (
	set flag=1
	goto :inactive_cards
)
if /i %_choice% == 6 (
	set flag=1
	goto :deleted_cards
)
if /i %_choice% == 7 (
	set flag=1
	goto :intermediate_files
)
if /i %_choice% == 666 (
	set flag=1
	goto :other_files
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == a (
	set flag=1
	goto :about
)
if %flag% EQU 0 (
	goto :start
)
:vghd_is_running
call :showTitle
echo  CLOSE ISTRIPPER BEFORE CONTINUING
echo --------------------------------------------
echo.
echo iStripper (vghd.exe) is running. Close iStripper and try again.
echo.
echo ------------------
echo  [R] Retry
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :vghd_is_running
if /i %_choice% == q exit
if /i %_choice% == r (
	set flag=1
	goto :%retry_label%
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :vghd_is_running
)
:key_not_found
call :showTitle
echo  ERROR: The value can not be found
echo --------------------------------------------
echo.
echo At least one path can not be found in the system registry.
echo Make sure that iStripper has been installed correctly.
echo.
echo ------------------
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :key_not_found
if /i %_choice% == q exit
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :key_not_found
)
:dir_not_found
call :showTitle
echo  ERROR: Directory can not be found
echo --------------------------------------------
echo.
echo The "data" or "models" directory can not be found.
echo Make sure that iStripper has been installed correctly and the paths
echo saved in the system registry refer to the correct folders.
echo.
echo ------------------
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :dir_not_found
if /i %_choice% == q exit
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :dir_not_found
)
:about
cls
echo -------------------------------------------------------------------------------
echo.
echo      About this program
echo.
echo -------------------------------------------------------------------------------
echo.
echo Remover for iStripper
echo.
echo version: 1.0 (2019-01-15)
echo author: LukaszR
echo webpage: www.isworkshop.eu
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :start
:help
cls
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo This tool will help you remove (delete) all unwanted iStripper clips.
echo.
echo Press 1 if you want to delete previews of non purchased and not downloaded
echo     cards. All demo files and empty folders will be deleted.
echo Press 2 if you want to delete all regular demo files saved on your disk.
echo     Interactive (transition) demo files will stay untouched. If there will
echo     be any empty folders after this operation, they will also be deleted.
echo     This process can take a long time, especially for large collections.
echo Press 3 if you want to delete all demo files (regular and interactive).
echo     All files with the .demo extension will be deleted. If there will be
echo     any empty folders after this operation, they will also be deleted.
echo Press 4 if you want to delete all inactive clips. All deactivated clips for
echo     every card in your collection will be deleted.
echo Press 5 if you want to delete all inactive cards. All deactivated cards and
echo     empty folders will be deleted.
echo Press 6 if you want to delete all deleted cards. If there are any files
echo     associated with the cards deleted with the GUI, they will be removed
echo     from disk. If there will be any empty folders, they will also be removed.
echo Press 7 if you want to delete all intermediate files. Useful if error
echo     "Cannot write intermediate file" is encountered.
echo     Intermediate files are created by iStripper when downloading shows. They
echo     are removed immediately after completing the download, however, they can
echo     remain on the disk if the program encounters an error during download.
echo Press H to display tips (this text).
echo Press A to display info about the program and its author.
echo Press Q to exit the program.
echo.
echo None of the above operations removes images associated with cards.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
pause >nul
goto :%current_label%
:demo_not_purchased
set "current_label=demo_not_purchased"
set "retry_label=demo_not_purchased"
call :checkIs
call :getFilepaths
call :showTitle
echo  1. REMOVE PREVIEWS OF NON PURCHASED CARDS
echo --------------------------------------------
echo.
echo You're about to remove all clips and folders of non purchased shows.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :demo_not_purchased
if /i %_choice% == q exit
if /i %_choice% == 1 (
	call :checkIs
	set flag=1
	goto :demo_not_purchased_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :demo_not_purchased
)
:demo_not_purchased_go
set _path=
set /a total_dirs=0
set /a current_dir=0
for /f %%i in ('copy /z "%~f0" nul') do set "CR=%%i"
call :countModelsFolders
:demo_not_purchased_retry
set "retry_label=demo_not_purchased_go"
call :showTitle
echo Removing previews of non purchased cards...
echo.
for /l %%i in (0,1,%total_paths%) do (
	set "_path=!models_path[%%i]!"
	for /f "tokens=*" %%j in ('dir /ad /-b "!_path!\?????" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ') do (
		call :checkIs
		set /a current_dir+=1
		set /a "progress=(!current_dir! * 100) / !total_dirs!"
		set /p "=Completed: !progress!%% (processing %%j)!CR!" <nul
		if not exist "!_path!\%%j\*.vghd" (
			rd /s /q "!_path!\%%j" >nul 2>&1
		)
	)
	echo Completed: !progress!%%                    
)
call :deleteLst
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:regular_demo
set "current_label=regular_demo"
set "retry_label=regular_demo"
call :checkIs
call :getFilepaths
call :showTitle
echo  2. REMOVE REGULAR DEMO FILES
echo -------------------------------
echo.
echo You're about to remove all regular previews of all shows saved on your disk.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :regular_demo
if /i %_choice% == q exit
if /i %_choice% == 1 (
	call :checkIs
	set flag=1
	goto :regular_demo_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :regular_demo
)
:regular_demo_go
set _path=
set /a total_dirs=0
set /a current_dir=0
for /f %%i in ('copy /z "%~f0" nul') do set "CR=%%i"
call :countModelsFolders
:regular_demo_retry
set "retry_label=regular_demo_go"
call :showTitle
echo Removing regular demo files...
echo.
for /l %%i in (0,1,%total_paths%) do (
	set "_path=!models_path[%%i]!"
	for /f "tokens=*" %%j in ('dir /ad /-b "!_path!\?????" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ') do (
		call :checkIs
		set /a current_dir+=1
		set /a "progress=(!current_dir! * 100) / !total_dirs!"
		set /p "=Completed: !progress!%% (processing %%j)!CR!" <nul
		if not exist "!_path!\%%j\*.vghd" (
			if not exist "!_path!\%%j\*it*.demo" (
				rd /s /q "!_path!\%%j" >nul 2>&1
			) else (
				for /f "tokens=*" %%k in ('dir /-b "!_path!\%%j\*.demo" 2^>nul ^| findstr /i /v it') do (
					del /q /f "!_path!\%%j\%%k" >nul 2>&1
				)
				del /q /f "!_path!\%%j\*.vhdtrailers" >nul 2>&1
				del /q /f "!_path!\%%j\*.vhdp2p" >nul 2>&1
			)
		) else (
			if not exist "!_path!\%%j\*it*.demo" (
				del /q /f "!_path!\%%j\*.demo" >nul 2>&1
			) else (
				for /f "tokens=*" %%k in ('dir /-b "!_path!\%%j\*.demo" 2^>nul ^| findstr /i /v it') do (
					del /q /f "!_path!\%%j\%%k" >nul 2>&1
				)
			)
			del /q /f "!_path!\%%j\*.vhdtrailers" >nul 2>&1
			del /q /f "!_path!\%%j\*.vhdp2p" >nul 2>&1
		)
	)
	echo Completed: !progress!%%                    
)
call :deleteLst
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:regular_interactive_demo
set "current_label=regular_interactive_demo"
set "retry_label=regular_interactive_demo"
call :checkIs
call :getFilepaths
call :showTitle
echo  3. REMOVE REGULAR AND INTERACTIVE DEMO FILES
echo -----------------------------------------------
echo.
echo You're about to remove all previews of all shows saved on your disk,
echo including regular previews and interactive (transition) demo files.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :regular_interactive_demo
if /i %_choice% == q exit
if /i %_choice% == 1 (
	call :checkIs
	set flag=1
	goto :regular_interactive_demo_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :regular_interactive_demo
)
:regular_interactive_demo_go
set _path=
set /a total_dirs=0
set /a current_dir=0
for /f %%i in ('copy /z "%~f0" nul') do set "CR=%%i"
call :countModelsFolders
:regular_interactive_demo_retry
set "retry_label=regular_interactive_demo_go"
call :showTitle
echo Removing all demo files...
echo.
for /l %%i in (0,1,%total_paths%) do (
	set "_path=!models_path[%%i]!"
	for /f "tokens=*" %%j in ('dir /ad /-b "!_path!\?????" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ') do (
		call :checkIs
		set /a current_dir+=1
		set /a "progress=(!current_dir! * 100) / !total_dirs!"
		set /p "=Completed: !progress!%% (processing %%j)!CR!" <nul
		if not exist "!_path!\%%j\*.vghd" (
			rd /s /q "!_path!\%%j" >nul 2>&1
		) else (
			del /q /f "!_path!\%%j\*.demo" >nul 2>&1
			del /q /f "!_path!\%%j\*.vhdtrailers" >nul 2>&1
			del /q /f "!_path!\%%j\*.vhdp2p" >nul 2>&1
		)
	)
	echo Completed: !progress!%%                    
)
call :deleteLst
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:inactive_clips
set "current_label=inactive_clips"
set "retry_label=inactive_clips"
call :checkIs
call :getFilepaths
call :showTitle
echo  4. REMOVE INACTIVE CLIPS
echo ---------------------------
echo.
echo You're about to remove all deactivated clips from your disk.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :inactive_clips
if /i %_choice% == q exit
if /i %_choice% == 1 (
	call :checkIs
	set flag=1
	goto :inactive_clips_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :inactive_clips
)
:inactive_clips_go
set _path=
set /a total_dirs=0
set /a current_dir=0
for /f %%i in ('copy /z "%~f0" nul') do set "CR=%%i"
call :countDataFolders
:inactive_clips_retry
set "retry_label=inactive_clips_go"
call :showTitle
echo Removing inactive clips...
echo.
for /f "tokens=*" %%g in ('dir /ad /-b "!data_path!\?????" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ') do (
	call :checkIs
	set /a current_dir+=1
	set /a "progress=(!current_dir! * 100) / !total_dirs!"
	set /p "=Completed: !progress!%% (processing %%g)!CR!" <nul
	if exist "!data_path!\%%g\inactive.txt" (
		set err_flag=0
		set _clips=
		set /p _clips=<!data_path!\%%g\inactive.txt
		if [!_clips!] NEQ [] (
			set _clips=!_clips:#= !
			for %%i in (!_clips!) do (
				for /l %%j in (0,1,!total_paths!) do (
					set "_path=!models_path[%%j]!"
					if exist "!_path!\%%g" (
						if exist "!_path!\%%g\%%i" (
							del /q /f "!_path!\%%g\%%i" >nul 2>&1
							if !ERRORLEVEL! NEQ 0 set err_flag=1
						)
						if not exist "!_path!\%%g\*.vghd" (
							if not exist "!_path!\%%g\*.demo" (
								rd /s /q "!_path!\%%g" >nul 2>&1
							)
						)
					)
				)
			)
		)
		if !err_flag! EQU 0 (
			ren "!data_path!\%%g\inactive.txt" "inactive.txt.backup" >nul 2>&1
		)
	)
)
echo Completed: !progress!%%                    
call :deleteLst
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:inactive_cards
set "current_label=inactive_cards"
set "retry_label=inactive_cards"
call :checkIs
call :getFilepaths
call :showTitle
echo  5. REMOVE INACTIVE CARDS
echo ---------------------------
echo.
echo You're about to remove all deactivated shows from your disk.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :inactive_cards
if /i %_choice% == q exit
if /i %_choice% == 1 (
	call :checkIs
	set flag=1
	goto :inactive_cards_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :inactive_cards
)
:inactive_cards_go
set _path=
set /a total_dirs=0
set /a current_dir=0
for /f %%i in ('copy /z "%~f0" nul') do set "CR=%%i"
call :countDataFolders
:inactive_cards_retry
set "retry_label=inactive_cards_go"
call :showTitle
echo Removing inactive cards...
echo.
for /f "tokens=*" %%g in ('dir /ad /-b "!data_path!\?????" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ') do (
	call :checkIs
	set /a current_dir+=1
	set /a "progress=(!current_dir! * 100) / !total_dirs!"
	set /p "=Completed: !progress!%% (processing %%g)!CR!" <nul
	if exist "!data_path!\%%g\%%g.vhddisabled" (
		for /l %%i in (0,1,!total_paths!) do (
			set "_path=!models_path[%%i]!"
			if exist "!_path!\%%g" (
				rd /s /q "!_path!\%%g" >nul 2>&1
			)
		)
	)
)
echo Completed: !progress!%%                    
call :deleteLst
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:deleted_cards
set "current_label=deleted_cards"
set "retry_label=deleted_cards"
call :checkIs
call :getFilepaths
call :showTitle
echo  6. REMOVE DELETED CARDS
echo --------------------------
echo.
echo You're about to remove all files associated with the shows you deleted
echo through the GUI. This function will remove files that could not be deleted
echo by the GUI. Empty folders will also be removed.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :deleted_cards
if /i %_choice% == q exit
if /i %_choice% == 1 (
	call :checkIs
	set flag=1
	goto :deleted_cards_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :deleted_cards
)
:deleted_cards_go
set _path=
set /a total_dirs=0
set /a current_dir=0
for /f %%i in ('copy /z "%~f0" nul') do set "CR=%%i"
call :countDataFolders
:deleted_cards_retry
set "retry_label=deleted_cards_go"
call :showTitle
echo Removing deleted cards...
echo.
for /f "tokens=*" %%g in ('dir /ad /-b "!data_path!\?????" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ') do (
	call :checkIs
	set /a current_dir+=1
	set /a "progress=(!current_dir! * 100) / !total_dirs!"
	set /p "=Completed: !progress!%% (processing %%g)!CR!" <nul
	if exist "!data_path!\%%g\%%g.vhddel" (
		for /l %%i in (0,1,!total_paths!) do (
			set "_path=!models_path[%%i]!"
			if exist "!_path!\%%g" (
				rd /s /q "!_path!\%%g" >nul 2>&1
			)
		)
	)
)
echo Completed: !progress!%%                    
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:intermediate_files
set "current_label=intermediate_files"
set "retry_label=intermediate_files"
call :checkIs
call :getFilepaths
call :showTitle
echo  7. REMOVE INTERMEDIATE FILES
echo -------------------------------
echo.
echo You're about to remove all intermediate files.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :intermediate_files
if /i %_choice% == q exit
if /i %_choice% == 1 (
	call :checkIs
	set flag=1
	goto :intermediate_files_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :intermediate_files
)
:intermediate_files_go
set _path=
set /a main_dirs=%total_paths%+2
set /a total_dirs=0
set /a current_dir=0
for /f %%i in ('copy /z "%~f0" nul') do set "CR=%%i"
:intermediate_files_retry
set "retry_label=intermediate_files_go"
call :showTitle
echo Removing intermediate files...
echo.
set /p "=Completed: 0%% (processing data)!CR!" <nul
del /q /f /s "%data_path%\*.dlmcdf" >nul 2>&1
del /q /f /s "%data_path%\*.vhdaskshows" >nul 2>&1
set /a current_dir+=1
set /a "progress=(%current_dir% * 100) / %main_dirs%"
set /p "=Completed: %progress%%% (processing data)!CR!" <nul
for /l %%i in (0,1,%total_paths%) do (
	del /q /f /s "!models_path[%%i]!\*.dlmcdf" >nul 2>&1
	set /a current_dir+=1
	set /a "progress=(!current_dir! * 100) / !main_dirs!"
	set /p "=Completed: !progress!%% (processing models)!CR!" <nul
)
echo Completed: !progress!%%                              
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:other_files
set "current_label=other_files"
set "retry_label=other_files"
call :getFilepaths
call :showTitle
echo  666. REMOVE OTHER FILES (hidden option)
echo ------------------------------------------
echo.
echo You're about to delete the following files from "data" folder:
echo.
echo      inactive.txt
echo      *.vhddisabled
echo      *.vhddel
echo      *.dlmcdf
echo      *.demo
echo      *.vhdaskshows
echo.
echo This action can not be undone.
echo Are you sure you want to remove them?
echo.
echo ------------------
echo  [1] Remove now^^!
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :other_files
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	goto :other_files_go
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :other_files
)
:other_files_go
set "retry_label=other_files_go"
call :showTitle
echo Removing useless files...
echo Please wait...
set _path=
del /q /f /s "%data_path%\inactive.txt" >nul 2>&1
del /q /f /s "%data_path%\*.vhddisabled" >nul 2>&1
del /q /f /s "%data_path%\*.vhddel" >nul 2>&1
del /q /f /s "%data_path%\*.dlmcdf" >nul 2>&1
del /q /f /s "%data_path%\*.demo" >nul 2>&1
del /q /f /s "%data_path%\*.vhdaskshows" >nul 2>&1
for /l %%i in (0,1,%total_paths%) do (
	set "_path=!models_path[%%i]!"
	del /q /f /s "!_path!\*.dlmcdf" >nul 2>&1
)
call :deleteLst
echo.
echo Done. Press any key to continue.
echo.
pause >nul
goto :done
:done
call :showTitle
echo Done. All unwanted clips and files have been removed.
echo What now?
echo.
echo ------------------------
echo  [B] Back to main menu
echo  [Q] Quit
echo ------------------------
echo.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :done
if /i %_choice% == q exit
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :done
)
:showTitle <module>
set "_title_line_1================================================================================"
set "_title_line_2=                                Remover (v1.0)"
set "_title_line_3================================================================================"
cls
set i_max=3
for /l %%i in (1,1,%i_max%) do (
	echo !_title_line_%%i!
	if %%i LSS !i_max! echo.
)
echo.
exit /b
:readRegValue <regKey> <regVarName> <resultType> <resultValue> <errorLevel>
for /f "tokens=2*" %%a in ('reg query %1 /v "%2" 2^>nul ^| find /i "%2"') do (
	set "%3=%%a"
	set "%4=%%b"
	set "%5=%ERRORLEVEL%"
)
exit /b
:getFilepaths
set reg_key=HKEY_CURRENT_USER\Software\Totem\vghd\System
set reg_var_data=DataPath
set reg_var_models=ModelsPath
set reg_var_multi=ModelsMultiPath
reg query %reg_key% /v %reg_var_data% >nul 2>&1 || goto :key_not_found
reg query %reg_key% /v %reg_var_models% >nul 2>&1 || goto :key_not_found
set data_path=
for /f "tokens=2*" %%i in ('reg query %reg_key% /v %reg_var_data% 2^>nul ^| findstr /i %reg_var_data%') do (
	set "tmp_var=%%j"
	if [!tmp_var:~-1!] EQU [\] (
		set "tmp_var=!tmp_var:~0,-1!"
	)
	if not exist "!tmp_var!" goto :dir_not_found
	set "data_path=!tmp_var!"
)
set models_path[0]=
for /f "tokens=2*" %%i in ('reg query %reg_key% /v %reg_var_models% 2^>nul ^| findstr /i %reg_var_models%') do (
	set "tmp_var=%%j"
	if [!tmp_var:~-1!] EQU [\] (
		set "tmp_var=!tmp_var:~0,-1!"
	)
	if not exist "!tmp_var!" goto :dir_not_found
	set "models_path[0]=!tmp_var!"
)
set multi_path=
set /a "total_paths=0"
for /f "tokens=2*" %%i in ('reg query %reg_key% /v %reg_var_multi% 2^>nul ^| findstr /i %reg_var_multi%') do (
	set multi_path="%%j"
)
if /i [%multi_path%] NEQ [] (
	call set multi_path=%multi_path:\0=" "%
	for %%i in (!multi_path!) do (
		if [%%i] NEQ [""] (
			set tmp_var=%%i
			set tmp_var=!tmp_var:~1,-1!
			if [!tmp_var:~-1!] EQU [\] (
				set "tmp_var=!tmp_var:~0,-1!"
			)
			if [!tmp_var!] NEQ [!models_path[0]!] (
				set /a "total_paths+=1"
				if not exist "!tmp_var!" goto :dir_not_found
				set models_path[!total_paths!]=!tmp_var!
			)
		)
	)
)
exit /b
:checkIs
qprocess vghd.exe >nul 2>&1 && (
	goto :vghd_is_running
)
exit /b
:deleteLst
if exist "%data_path%\models.lst" (
	copy /b /y "%data_path%\models.lst" "%data_path%\models.lst.backup" >nul 2>&1
	del /q /f "%data_path%\models.lst" >nul 2>&1
)
exit /b
:countDataFolders
set /a total_dirs=0
for /f %%i in ('dir /ad /-b "!data_path!" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ^| find /c /v "" ') do set /a total_dirs+=%%i
exit /b
:countModelsFolders
for /l %%i in (0,1,%total_paths%) do (
	set "_path=!models_path[%%i]!\"
	for /f %%i in ('dir /ad /-b "!_path!" 2^>nul ^| findstr /i /r "^[a-i][0-9][0-9][0-9][0-9]$" ^| find /c /v "" ') do set /a total_dirs+=%%i
)
exit /b
